---
title: Xamarin.Android error XA4215
description: XA4215 error code
ms.date: 01/15/2019
---
# Xamarin.Android error XA4215

## Example messages

```
error XA4215: The Java type `com.contoso.library1.Class1` is generated by more than one managed type. Please change the [Register] attribute so that the same Java type is not emitted.
error XA4215:   `com.contoso.library1.Class1` generated by: Library1.Class1, Library1, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
error XA4215:   `com.contoso.library1.Class1` generated by: Library1.Class1, Library2, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
```

## Issue

This error indicates that two or more C# types are emitting the same fully
qualified Java type name.

## Solution

To resolve this error, change the `[Register]` attribute on one of the C# types
to a different Java type name.
